package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.WFWorkflow;

/**
 * 实体[WFAction] 数据对象
 */
@TableName(value = "T_SRFWFACTION",resultMap = "WFActionResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFAction extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private WFWorkflow wfworkflow;
    private String actioncode;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String memo;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "wfactionid",type=IdType.UUID)//指定主键生成策略
    private String wfactionid;
    private String wfactionname;
    private String wfworkflowid;
    @TableField(exist = false)//逻辑属性
    private String wfworkflowname;
    /**
     *  设置属性值[行为代码]
     *  @param actioncode
     */
    public void setActioncode(String actioncode){
        if(StringUtils.isEmpty(actioncode))
            actioncode=null;
        this.actioncode = actioncode;
        this.set("actioncodedirtyflag",true);
    }
    /**
     *  获取属性值[行为代码]
     */
    public String getActioncode(){
        return this.actioncode;
    }
    /**
     *  重置属性值[行为代码]
     */
    public void resetActioncode(){
        this.set("actioncodedirtyflag",false);
        this.actioncode = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[备注]
     *  @param memo
     */
    public void setMemo(String memo){
        if(StringUtils.isEmpty(memo))
            memo=null;
        this.memo = memo;
        this.set("memodirtyflag",true);
    }
    /**
     *  获取属性值[备注]
     */
    public String getMemo(){
        return this.memo;
    }
    /**
     *  重置属性值[备注]
     */
    public void resetMemo(){
        this.set("memodirtyflag",false);
        this.memo = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流用户操作标识]
     *  @param wfactionid
     */
    public void setWfactionid(String wfactionid){
        if(StringUtils.isEmpty(wfactionid))
            wfactionid=null;
        this.wfactionid = wfactionid;
        this.set("wfactioniddirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户操作标识]
     */
    public String getWfactionid(){
        return this.wfactionid;
    }
    /**
     *  重置属性值[工作流用户操作标识]
     */
    public void resetWfactionid(){
        this.set("wfactioniddirtyflag",false);
        this.wfactionid = null;
    }
    /**
     *  设置属性值[工作流用户操作名称]
     *  @param wfactionname
     */
    public void setWfactionname(String wfactionname){
        if(StringUtils.isEmpty(wfactionname))
            wfactionname=null;
        this.wfactionname = wfactionname;
        this.set("wfactionnamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流用户操作名称]
     */
    public String getWfactionname(){
        return this.wfactionname;
    }
    /**
     *  重置属性值[工作流用户操作名称]
     */
    public void resetWfactionname(){
        this.set("wfactionnamedirtyflag",false);
        this.wfactionname = null;
    }
    /**
     *  设置属性值[工作流配置]
     *  @param wfworkflowid
     */
    public void setWfworkflowid(String wfworkflowid){
        if(StringUtils.isEmpty(wfworkflowid))
            wfworkflowid=null;
        this.wfworkflowid = wfworkflowid;
        this.set("wfworkflowiddirtyflag",true);
    }
    /**
     *  获取属性值[工作流配置]
     */
    public String getWfworkflowid(){
        return this.wfworkflowid;
    }
    /**
     *  重置属性值[工作流配置]
     */
    public void resetWfworkflowid(){
        this.set("wfworkflowiddirtyflag",false);
        this.wfworkflowid = null;
    }
    /**
     *  设置属性值[工作流配置]
     *  @param wfworkflowname
     */
    public void setWfworkflowname(String wfworkflowname){
        if(StringUtils.isEmpty(wfworkflowname))
            wfworkflowname=null;
        this.wfworkflowname = wfworkflowname;
        this.set("wfworkflownamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流配置]
     */
    public String getWfworkflowname(){
        return this.wfworkflowname;
    }
    /**
     *  重置属性值[工作流配置]
     */
    public void resetWfworkflowname(){
        this.set("wfworkflownamedirtyflag",false);
        this.wfworkflowname = null;
    }
     /**
     *  获取主实体关联数据[WFWorkflow]
     */
    public WFWorkflow getWfworkflow() {
        return wfworkflow;
    }
    /**
     *  设置主实体关联数据[WFWorkflow]
     */
    public void setWfworkflow(WFWorkflow wfworkflow) {
        this.wfworkflow = wfworkflow;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetActioncode();
        resetCreatedate();
        resetCreateman();
        resetMemo();
        resetUpdatedate();
        resetUpdateman();
        resetWfactionid();
        resetWfactionname();
        resetWfworkflowid();
        resetWfworkflowname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFAction copyTo(WFAction targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFAction.class, WFAction.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfactionid();
		return targetEntity;
	}
}